// figura1.h - Klasa geometrijskih figura u ravni.

#ifndef _figura1_h_
#define _figura1_h_

#include "tacka4.h"

class Figura {
  Tacka T;                                 // Teziste figure.
public:
  Figura(const Tacka& tt=ORG): T(tt)  {}   // Konstruktor.
  virtual ~Figura() {}                     // Destruktor.
  Figura& premesti(Real x, Real y)         // Premesanje figure.
    { T = Tacka(x, y); return *this; }
  Figura& pomeri(Real dx, Real dy)         // Pomeranje figure.
    { T = Tacka(T.aps()+dx, T.ord()+dy); return *this; }
  virtual Real O() const =0;               // Obim.
  virtual Real P() const =0;               // Povrsina.
  virtual Figura* kopija() const =0;       // Kopiranje.
protected:
  virtual void citaj(istream& ut)       { ut >> T; }         // Citanje.
  friend istream& operator>>(istream& ut, Figura& f)
    { f.citaj(ut); return ut; }
  virtual void pisi (ostream& it) const { it << "T=" << T; } // Pisanje.
  friend ostream& operator<<(ostream& it, const Figura& f)
    { f.pisi(it); return it; }
};

#endif

