// monom.h - Klasa monoma.

#ifndef _monom_h_
#define _monom_h_

#include "fun3.h"
#include <cmath>
using namespace std;

namespace Izvodi {
  class Monom: public Fun {
    double a, b;                               // Parametri monoma.
    void pisi(ostream& it) const override      // Pisanje monoma.
      { it << a << "*x^" << b; }
  public:
    Monom(double aa=1, double bb=1)            // Stvaranje monoma.
      { a = aa; b = bb; }
    double operator()(double x) const override // Racunanje vrednosti.
      { return a * pow(x, b); }
    Delegat izvod() const override             // Izvod monoma.
      { return Delegat(new Monom(a*b, b-1)); }
    Monom* kopija() const override             // Kopija monoma.
      { return new Monom(*this); }
  }; // class Monom
} // namespace Izvodi

#endif

