// niz1.h - Klasa nizova realnih brojeva.

#ifndef _niz1_h_
#define _niz1_h_

class Niz {
  double* a; int n;                           // Niz i duzina niza.
  void kopiraj(const Niz& niz);               // Kopiranje u niz.
  void premesti(Niz& niz)                     // Premestanje u niz.
    { a = niz.a; n = niz.n; niz.a = nullptr; }
  void brisi() { delete [] a; }               // Oslobadjanje memorije.
public:
  explicit Niz(int k=10) { a = new double [n = k]; } // Stvaranje niza.
  Niz(const Niz& niz) { kopiraj(niz); }       // Inicijalizacija nizom.
  Niz(Niz&& niz) { premesti(niz); }
  ~Niz() { delete [] a; }                     // Unistavanje.
  Niz& operator=(const Niz& niz) {            // Dodela vrednosti.
    if(this != &niz) { brisi(); kopiraj(niz); }
    return *this;
  }
  Niz& operator=(Niz&& niz) {
    if(this != &niz) { brisi(); premesti(niz); }
    return *this;
  }
  double& operator[](int i) {                 // Pristup elementu
    if (i<0 || i>=n) throw i;                 // - promenljivog niza,
    return a[i];
  }
  const double& operator[](int i) const {     // - nepromenljivog niza.
    if (i<0 || i>=n) throw i;
    return a[i];
  }
  int duz() const { return n; }               // Duzina niza.
};

#endif

